import { type IType, PrimaryKeyProp, defineEntity, p } from '@mikro-orm/core';

export class ScsUsermessage {
  [PrimaryKeyProp]?: 'Id';
  Id!: IType<number, bigint>;
  UserId!: IType<number, bigint>;
  Title?: string;
  IsRead!: number;
  ReadTime!: Date;
  IsImportant!: number;
  Revision!: number;
  CreatedBy?: IType<number, bigint>;
  CreatedTime!: Date;
  UpdatedBy?: IType<number, bigint>;
  UpdatedTime?: Date;
  IsDeleted!: unknown;
}

export const ScsUsermessageSchema = defineEntity({
  class: ScsUsermessage,
  comment: '用户消息表',
  properties: {
    Id: p.bigint().primary().name('Id').columnType('bigint').unsigned(false).autoincrement(false).comment('主键Id'),
    UserId: p.bigint().name('UserId').columnType('bigint').comment('用户id'),
    Title: p.string().name('Title').nullable().comment('消息'),
    IsRead: p.integer().name('IsRead').comment('是否已读'),
    ReadTime: p.datetime().name('ReadTime').length(3).comment('已读时间'),
    IsImportant: p.integer().name('IsImportant').comment('是否重要'),
    Revision: p.integer().name('Revision').comment('乐观锁'),
    CreatedBy: p.bigint().name('CreatedBy').columnType('bigint').nullable().comment('创建者用户Id'),
    CreatedTime: p.datetime().name('CreatedTime').length(3).comment('创建时间'),
    UpdatedBy: p.bigint().name('UpdatedBy').columnType('bigint').nullable().comment('修改者用户Id'),
    UpdatedTime: p.datetime().name('UpdatedTime').length(3).nullable().comment('修改时间'),
    IsDeleted: p.array().name('IsDeleted').comment('是否删除'),
  },
});
